/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-pddl-msgs-0.1.4-1quantal-20150619-1841/msg/PDDLDomain.msg
 *
 */


#ifndef PDDL_MSGS_MESSAGE_PDDLDOMAIN_H
#define PDDL_MSGS_MESSAGE_PDDLDOMAIN_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <pddl_msgs/PDDLAction.h>

namespace pddl_msgs
{
template <class ContainerAllocator>
struct PDDLDomain_
{
  typedef PDDLDomain_<ContainerAllocator> Type;

  PDDLDomain_()
    : name()
    , requirements()
    , types()
    , constants()
    , predicates()
    , actions()
    , functions()  {
    }
  PDDLDomain_(const ContainerAllocator& _alloc)
    : name(_alloc)
    , requirements(_alloc)
    , types(_alloc)
    , constants(_alloc)
    , predicates(_alloc)
    , actions(_alloc)
    , functions(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _name_type;
  _name_type name;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _requirements_type;
  _requirements_type requirements;

   typedef std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > , typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::other >  _types_type;
  _types_type types;

   typedef std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > , typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::other >  _constants_type;
  _constants_type constants;

   typedef std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > , typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::other >  _predicates_type;
  _predicates_type predicates;

   typedef std::vector< ::pddl_msgs::PDDLAction_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::pddl_msgs::PDDLAction_<ContainerAllocator> >::other >  _actions_type;
  _actions_type actions;

   typedef std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > , typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::other >  _functions_type;
  _functions_type functions;




  typedef boost::shared_ptr< ::pddl_msgs::PDDLDomain_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::pddl_msgs::PDDLDomain_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct PDDLDomain_

typedef ::pddl_msgs::PDDLDomain_<std::allocator<void> > PDDLDomain;

typedef boost::shared_ptr< ::pddl_msgs::PDDLDomain > PDDLDomainPtr;
typedef boost::shared_ptr< ::pddl_msgs::PDDLDomain const> PDDLDomainConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::pddl_msgs::PDDLDomain_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::pddl_msgs::PDDLDomain_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace pddl_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'pddl_msgs': ['/tmp/buildd/ros-hydro-pddl-msgs-0.1.4-1quantal-20150619-1841/obj-i686-linux-gnu/devel/share/pddl_msgs/msg', '/tmp/buildd/ros-hydro-pddl-msgs-0.1.4-1quantal-20150619-1841/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::pddl_msgs::PDDLDomain_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::pddl_msgs::PDDLDomain_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pddl_msgs::PDDLDomain_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pddl_msgs::PDDLDomain_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pddl_msgs::PDDLDomain_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pddl_msgs::PDDLDomain_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::pddl_msgs::PDDLDomain_<ContainerAllocator> >
{
  static const char* value()
  {
    return "efae1c485597d25a68729e978f828ed8";
  }

  static const char* value(const ::pddl_msgs::PDDLDomain_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xefae1c485597d25aULL;
  static const uint64_t static_value2 = 0x68729e978f828ed8ULL;
};

template<class ContainerAllocator>
struct DataType< ::pddl_msgs::PDDLDomain_<ContainerAllocator> >
{
  static const char* value()
  {
    return "pddl_msgs/PDDLDomain";
  }

  static const char* value(const ::pddl_msgs::PDDLDomain_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::pddl_msgs::PDDLDomain_<ContainerAllocator> >
{
  static const char* value()
  {
    return "string name\n\
string requirements\n\
string[] types\n\
string[] constants\n\
string[] predicates\n\
pddl_msgs/PDDLAction[] actions\n\
string[] functions\n\
\n\
================================================================================\n\
MSG: pddl_msgs/PDDLAction\n\
string name\n\
# write String in S expression like \"(and foo var)\"\n\
string parameters\n\
string precondition\n\
string effect\n\
string on_condition\n\
";
  }

  static const char* value(const ::pddl_msgs::PDDLDomain_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::pddl_msgs::PDDLDomain_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.name);
      stream.next(m.requirements);
      stream.next(m.types);
      stream.next(m.constants);
      stream.next(m.predicates);
      stream.next(m.actions);
      stream.next(m.functions);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct PDDLDomain_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::pddl_msgs::PDDLDomain_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::pddl_msgs::PDDLDomain_<ContainerAllocator>& v)
  {
    s << indent << "name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.name);
    s << indent << "requirements: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.requirements);
    s << indent << "types[]" << std::endl;
    for (size_t i = 0; i < v.types.size(); ++i)
    {
      s << indent << "  types[" << i << "]: ";
      Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.types[i]);
    }
    s << indent << "constants[]" << std::endl;
    for (size_t i = 0; i < v.constants.size(); ++i)
    {
      s << indent << "  constants[" << i << "]: ";
      Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.constants[i]);
    }
    s << indent << "predicates[]" << std::endl;
    for (size_t i = 0; i < v.predicates.size(); ++i)
    {
      s << indent << "  predicates[" << i << "]: ";
      Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.predicates[i]);
    }
    s << indent << "actions[]" << std::endl;
    for (size_t i = 0; i < v.actions.size(); ++i)
    {
      s << indent << "  actions[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::pddl_msgs::PDDLAction_<ContainerAllocator> >::stream(s, indent + "    ", v.actions[i]);
    }
    s << indent << "functions[]" << std::endl;
    for (size_t i = 0; i < v.functions.size(); ++i)
    {
      s << indent << "  functions[" << i << "]: ";
      Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.functions[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // PDDL_MSGS_MESSAGE_PDDLDOMAIN_H
