/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-pddl-msgs-0.1.4-1quantal-20150619-1841/obj-i686-linux-gnu/devel/share/pddl_msgs/msg/PDDLPlannerGoal.msg
 *
 */


#ifndef PDDL_MSGS_MESSAGE_PDDLPLANNERGOAL_H
#define PDDL_MSGS_MESSAGE_PDDLPLANNERGOAL_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <pddl_msgs/PDDLDomain.h>
#include <pddl_msgs/PDDLProblem.h>

namespace pddl_msgs
{
template <class ContainerAllocator>
struct PDDLPlannerGoal_
{
  typedef PDDLPlannerGoal_<ContainerAllocator> Type;

  PDDLPlannerGoal_()
    : domain()
    , problem()  {
    }
  PDDLPlannerGoal_(const ContainerAllocator& _alloc)
    : domain(_alloc)
    , problem(_alloc)  {
    }



   typedef  ::pddl_msgs::PDDLDomain_<ContainerAllocator>  _domain_type;
  _domain_type domain;

   typedef  ::pddl_msgs::PDDLProblem_<ContainerAllocator>  _problem_type;
  _problem_type problem;




  typedef boost::shared_ptr< ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct PDDLPlannerGoal_

typedef ::pddl_msgs::PDDLPlannerGoal_<std::allocator<void> > PDDLPlannerGoal;

typedef boost::shared_ptr< ::pddl_msgs::PDDLPlannerGoal > PDDLPlannerGoalPtr;
typedef boost::shared_ptr< ::pddl_msgs::PDDLPlannerGoal const> PDDLPlannerGoalConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace pddl_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'pddl_msgs': ['/tmp/buildd/ros-hydro-pddl-msgs-0.1.4-1quantal-20150619-1841/obj-i686-linux-gnu/devel/share/pddl_msgs/msg', '/tmp/buildd/ros-hydro-pddl-msgs-0.1.4-1quantal-20150619-1841/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "1c616a007e540287d36771fae579cf3a";
  }

  static const char* value(const ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x1c616a007e540287ULL;
  static const uint64_t static_value2 = 0xd36771fae579cf3aULL;
};

template<class ContainerAllocator>
struct DataType< ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "pddl_msgs/PDDLPlannerGoal";
  }

  static const char* value(const ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
# goal\n\
pddl_msgs/PDDLDomain domain\n\
pddl_msgs/PDDLProblem problem\n\
\n\
================================================================================\n\
MSG: pddl_msgs/PDDLDomain\n\
string name\n\
string requirements\n\
string[] types\n\
string[] constants\n\
string[] predicates\n\
pddl_msgs/PDDLAction[] actions\n\
string[] functions\n\
\n\
================================================================================\n\
MSG: pddl_msgs/PDDLAction\n\
string name\n\
# write String in S expression like \"(and foo var)\"\n\
string parameters\n\
string precondition\n\
string effect\n\
string on_condition\n\
\n\
================================================================================\n\
MSG: pddl_msgs/PDDLProblem\n\
string name          # name of problem\n\
string domain        # name of domain to use\n\
pddl_msgs/PDDLObject[] objects # how to represent type?\n\
string[] initial     # initial condition\n\
string goal          # goal conjunction\n\
string metric        # metric\n\
\n\
\n\
================================================================================\n\
MSG: pddl_msgs/PDDLObject\n\
# definition of PDDLObject\n\
string name\n\
string type\n\
";
  }

  static const char* value(const ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.domain);
      stream.next(m.problem);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct PDDLPlannerGoal_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::pddl_msgs::PDDLPlannerGoal_<ContainerAllocator>& v)
  {
    s << indent << "domain: ";
    s << std::endl;
    Printer< ::pddl_msgs::PDDLDomain_<ContainerAllocator> >::stream(s, indent + "  ", v.domain);
    s << indent << "problem: ";
    s << std::endl;
    Printer< ::pddl_msgs::PDDLProblem_<ContainerAllocator> >::stream(s, indent + "  ", v.problem);
  }
};

} // namespace message_operations
} // namespace ros

#endif // PDDL_MSGS_MESSAGE_PDDLPLANNERGOAL_H
